{$IFDEF PROFILE} {$WARNINGS OFF} {$ENDIF }
{$IFDEF PROFILE} {    Do not delete previous line(s) !!! } {$ENDIF }
{$IFDEF PROFILE} { Otherwise sources can not be cleaned !!! } {$ENDIF }
unit Protmain1;

interface

uses
  SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls{$IFNDEF PROFILE};{$ELSE}{},Profinl, Profonli;{$ENDIF}

type

  { TForm1 }

  TForm1 = class(TForm)
    ListBox1: TListBox;
    ListBox2: TListBox;
    Label1: TLabel;
    Label2: TLabel;
    Opti: TCheckBox;
    Button1: TButton;
    Warnlab: TLabel;
    ResLabel: TLabel;
    reslab1: TLabel;
    reslab2: TLabel;
    procedure InitBox(Sender: TObject);
    procedure SortThem(Sender: TObject);
  private
    { Private declarations }
    PROCEDURE DeleteBox2;
    PROCEDURE CopyToListBox2;
    PROCEDURE LabelOn;
    PROCEDURE Sort ( entries : Integer) ;
    PROCEDURE Tausche ( x, y : INTEGER );
    PROCEDURE UnusedFuncForDemo;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}
CONST
  Content : Array[0..74] OF String = ('Oldenburg*Germany',
  'Fuerth*Germany',
  'New York*USA',
  'London*Great Britain',
  'Cairns*Australia',
  'Melbourne*Australia',
  'Adelaide*Australia',
  'Port Louis*Mauritius',
  'Bridgetown*Barbados',
  'Lisboa*Portugal',
  'Den Helder*Netherlands',
  'Utrecht*Netherlands',
  'Hilversum*Netherlands',
  'Enschede*Netherlands',
  'Paris*France',
  'Barcelona*Spain',
  'Frankfort*Germany',
  'Singapore*Singapore',
  'Bangkok*Thailand',
  'Denpasar*Indonesia',
  'Johannesburg*South Africa',
  'Brussels*Belgium',
  'Berlin*Germany',
  'Paderborn*Germany',
  'Monaco*Monaco',
  'Rejkjavik*Iceland',
  'Minneapolis*USA',
  'Bangalore*India',
  'Pnom Penh*Cambodia',
  'Groningen*Netherlands',
  'Copenhagen*Denmark',
  'Prague*Czech Republic',
  'Vienna*Austria',
  'Zuerich*Switzerland',
  'St. Louis*USA',
  'New Orleans*USA',
  'Halifax*Canada',
  'Toronto*Canada',
  'Dublin*Ireland',
  'Belfast*Northern Ireland',
  'Helsinki*Finland',
  'Stockholm*Sweden',
  'Munich*Germany',
  'Nuremberg*Germany',
  'Saint Tropez*France',
  'Cartagena*Spain',
  'Ulan Bator*Mongolia',
  'Teipei*Taiwan',
  'Beijing*China',
  'Shenzhen*China',
  'Krakau*Poland',
  'Warzawa*Poland',
  'Dunedin*New Zealand',
  'Christchurch*New Zealand',
  'Wellington*New Zealand',
  'Auckland*New Zealand',
  'St. Peter Port*Jersey',
  'Santa Barbara*USA',
  'Wichita Falls*USA',
  'Hoogeveen*Netherlands',
  'Rijsweg*Netherlands',
  'Aalborg*Denmark',
  'Odensee*Denmark',
  'Valetta*Malta',
  'Palermo*Italy',
  'Bolzano*Italy',
  'Salt Lake City*USA',
  'Birmingham*Great Britain',
  'Glasgow*Scotland',
  'Southhampton*Great Britain',
  'Bournemouth*Great Britain',
  'Torquai*Great Britain',
  'Delmenhorst*Germany',
  'Bremen*Germany',
  'Hamburg*Germany'
  );
  ALLE = 2;

PROCEDURE TForm1.DeleteBox2;
BEGIN
{$IFDEF PROFILE}Profinl.ProfStop; Try; Profinl.ProfEnter(@self,2 or $80BC0000); {$ENDIF}
  ListBox2.Items.Clear;
  ListBox2.Update;
{$IFDEF PROFILE}finally; Profinl.ProfExit(2); end;{$ENDIF}
END;

//PROFILE-NO
PROCEDURE TForm1.Tausche ( x, y : INTEGER );
VAR
  temp : String;
BEGIN
  temp        := ListBox2.Items.Strings[x];
  ListBox2.Items.Strings[x] := ListBox2.Items.Strings[y];
  ListBox2.Items.Strings[y] := temp;
END;
//PROFILE-YES

PROCEDURE TForm1.Sort( entries : Integer );
VAR
  i, j, incr : Integer;
  s1, s2     : String;
  Found      : Boolean;
BEGIN
{$IFDEF PROFILE}Profinl.ProfStop; Try; Profinl.ProfEnter(@self,3 or $80BC0000); {$ENDIF}
  IF opti.Checked = FALSE THEN BEGIN
    Found := TRUE;
    WHILE TRUE DO BEGIN
      IF Found = FALSE THEN
        Break;
      Found := FALSE;
      i  := 0;
      s1 := ListBox2.Items.Strings[i];
      WHILE  i < entries - 1 DO BEGIN
        s2 := ListBox2.Items.Strings[i+1];
        IF s1 <= s2 THEN
          s1 := s2
        ELSE BEGIN
          ListBox2.Items.Strings[i]   := s2;
          ListBox2.Items.Strings[i+1] := s1;
          Found := True;
        END;
        INC(i);
      END;
    END;
    END
  ELSE BEGIN
    incr := (entries - 1) SHR 1;
    WHILE incr > 0 DO BEGIN
      FOR i := incr TO entries-1 DO BEGIN
        j := i - incr;
        WHILE j >= 0 DO BEGIN
          IF ListBox2.Items.Strings[j] > ListBox2.Items.Strings[j+incr] THEN BEGIN
            Tausche (j,j+incr);
            j := j - incr;
            END
          ELSE
            break;
        END;
      END;
      incr := incr SHR 1;
    END;
  END;
{$IFDEF PROFILE}finally; Profinl.ProfExit(3); end;{$ENDIF}
END;

PROCEDURE TForm1.CopyToListBox2;
VAR
  i, n : Integer;
BEGIN
{$IFDEF PROFILE}Profinl.ProfStop; Try; Profinl.ProfEnter(@self,4 or $80BC0000); {$ENDIF}
  n := ListBox1.Items.Count;
  FOR i := 0 TO n-1 DO
    ListBox2.Items.Add(ListBox1.Items.Strings[i]);
{$IFDEF PROFILE}finally; Profinl.ProfExit(4); end;{$ENDIF}
END;

PROCEDURE TForm1.LabelOn;
BEGIN
{$IFDEF PROFILE}Profinl.ProfStop; Try; Profinl.ProfEnter(@self,5 or $80BC0000); {$ENDIF}
  {$IFDEF      PROFILE } ResLabel.Visible := TRUE;  {$ENDIF }
  {$IFNDEF     PROFILE } WarnLab.visible := TRUE;   {$ENDIF }
{$IFDEF PROFILE}finally; Profinl.ProfExit(5); end;{$ENDIF}
END;

procedure TForm1.SortThem(sender: TObject);
VAR
  n       : Integer;
begin
{$IFDEF PROFILE}Profinl.ProfStop; Try; Profinl.ProfEnter(@self,6 or $80BC0000); {$ENDIF}
  Button1.Enabled := FALSE;
  DeleteBox2;
  CopyToListBox2;
  ListBox2.Update;
  n := ListBox1.Items.Count;
  Sort(n);
  Button1.Enabled := TRUE;
  LabelOn;
{$IFDEF PROFILE}finally; Profinl.ProfExit(6); end;{$ENDIF}
end;

procedure TForm1.InitBox(Sender: TObject);
VAR
  i, n, l : Integer;
  s       : String;
BEGIN
{$IFDEF PROFILE}Profinl.ProfStop; Try; Profinl.ProfEnter(@self,7 or $80BC0000); {$ENDIF}
  ListBox1.Items.Clear;
  FOR i := 0 TO 74 DO BEGIN
    s := Content[i];
    n := POS('*',s);
    l := Length(s);
    s := LeftStr(s,n-1) + LeftStr('               ',18 - n) + RightStr(s,l-n);
    ListBox1.Items.Add(s);
    ListBox2.Items.Add(s);
  END;
{$IFDEF PROFILE}finally; Profinl.ProfExit(7); end;{$ENDIF}
END;

PROCEDURE TForm1.UnusedFuncForDemo;
BEGIN
{$IFDEF PROFILE}Profinl.ProfStop; Try; Profinl.ProfEnter(@self,8 or $80BC0000); {$ENDIF}
{$IFDEF PROFILE}finally; Profinl.ProfExit(8); end;{$ENDIF}
END;

end.
